library(ggplot2)
library(reshape2)
library(RColorBrewer)
library(vegan)
library(ggplot2)
library(reshape2)
library(RColorBrewer)
require(gridExtra)

#####################################
########  index calculation  ########
#####################################

########benthos#######
specnames_benthos <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\spenames_bs.rds")
specnames_benthos2 <- specnames_benthos[c(1,2,5:20,24)]
specnames_plant <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\specnames_plant.rds")

#em_pre <- read.csv("C:\\Users\\xwu\\python_working\\1dTidalModel\\output\\benthos\\T_2000_whole.csv",stringsAsFactors = F)
sal_pre=c(28.66,24.82,21.51)
sal_zone <- c("Sterk polyhalien","Zwak polyhalien","Mesohalien")

#########plot with time#######
#open_duration <- data.frame(c(52,23,12),#flat
#                            c(50,22,11),
#                            c(48,21,11))

# open_duration <- data.frame(c(69,32,17),#slope
#                             c(66,30,16),
#                             c(64,28,15))

for(j in 1:3){#sal
  index_total_benthos<- data.frame(matrix(0, nrow = 100, ncol =3))
  index_total_plant<- data.frame(matrix(0, nrow = 100, ncol =3))
  index_biomass_total<- data.frame(matrix(0, nrow = 100, ncol =3))
  
  for(i in 1:3){#ssc
    for(t in 1:100){
      #benthos
      result_benthos_t <- data.frame(matrix(NA, nrow = 200, ncol =length(specnames_benthos2)))
      colnames(result_benthos_t)<-specnames_benthos2
      for(l in c(1,2,5:20,24)){
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_slope/logistic/logistic_spe",l,"_sal",j,".csv"))
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_ele/logistic/logistic_spe",l,"_sal",j,"_-1.csv"))
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000/logistic/logistic_spe",l,"_sal",j,".csv"))
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_slr0/logistic/logistic_spe",l,"_sal",j,".csv"))
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_slope_slr0/logistic/logistic_spe",l,"_sal",j,".csv"))
        result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_ele_slr0/logistic/logistic_spe",l,"_sal",j,"_1.csv"))
        result_benthos_t[specnames_benthos[l]] <- as.numeric(as.vector(result_benthos[t,1:200]))
      }
      ######index calculation#####
      gam_benthos <- apply(result_benthos_t, 1, function(x) {exp(mean(log(x+1)))-1})
      index_total_benthos[t,i] <- mean(gam_benthos)
      
      #plant
      result_plant_t <- data.frame(matrix(NA, nrow = 201, ncol =length(specnames_plant)))
      colnames(result_plant_t)<-specnames_plant
      for(l in 1:17){
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000/100years/lowdynam/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_slope/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_ele/plant_median_sal", j,"_spe",l,"_-1.csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_slr0/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_slope_slr0/plant_median_sal", j,"_spe",l,".csv"))
        result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_ele_slr0/plant_median_sal", j,"_spe",l,"_1.csv"))
        result_plant_t[specnames_plant[l]] <- as.numeric(as.vector(result_plant[t,]))
      }
      ######index calculation#####
      gam_plant <- apply(result_plant_t, 1, function(x) {exp(mean(log(x+1)))-1})
      
      index_total_plant[t,i] <- mean(gam_plant)
      
      #total
      result_spe_t <- merge(result_benthos_t,result_plant_t)
      biomass_total <- apply(result_spe_t, 1, function(x) {exp(mean(log(x+1)))-1})
      index_biomass_total[t,i] <- mean(biomass_total)
    }
  }
  # write.csv(index_total_benthos,paste0("./output/result_data/index/1000/biomass_benthos_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_total_plant,paste0("./output/result_data/index/1000/biomass_plant_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_biomass_total,paste0("./output/result_data/index/1000/biomass_total_sal", j,".csv"),row.names=FALSE)
  
  #write.csv(index_total_benthos,paste0("./output/result_data/index/1000_ele/biomass_benthos_sal", j,"_-1.csv"),row.names=FALSE)
  #write.csv(index_total_plant,paste0("./output/result_data/index/1000_ele/biomass_plant_sal", j,"_-1.csv"),row.names=FALSE)
  #write.csv(index_biomass_total,paste0("./output/result_data/index/1000_ele/biomass_total_sal", j,"_-1.csv"),row.names=FALSE)
  
  # write.csv(index_total_benthos,paste0("./output/result_data/index/1000_slr0/biomass_benthos_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_total_plant,paste0("./output/result_data/index/1000_slr0/biomass_plant_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_biomass_total,paste0("./output/result_data/index/1000_slr0/biomass_total_sal", j,".csv"),row.names=FALSE)
  
  # write.csv(index_total_benthos,paste0("./output/result_data/index/1000_slope_slr0/biomass_benthos_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_total_plant,paste0("./output/result_data/index/1000_slope_slr0/biomass_plant_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_biomass_total,paste0("./output/result_data/index/1000_slope_slr0/biomass_total_sal", j,".csv"),row.names=FALSE)
  
  # write.csv(index_total_benthos,paste0("./output/result_data/index/1000_slope/biomass_benthos_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_total_plant,paste0("./output/result_data/index/1000_slope/biomass_plant_sal", j,".csv"),row.names=FALSE)
  # write.csv(index_biomass_total,paste0("./output/result_data/index/1000_slope/biomass_total_sal", j,".csv"),row.names=FALSE)
  
  write.csv(index_total_benthos,paste0("./output/result_data/index/1000_ele_slr0/biomass_benthos_sal", j,"_1.csv"),row.names=FALSE)
  write.csv(index_total_plant,paste0("./output/result_data/index/1000_ele_slr0/biomass_plant_sal", j,"_1.csv"),row.names=FALSE)
  write.csv(index_biomass_total,paste0("./output/result_data/index/1000_ele_slr0/biomass_total_sal", j,"_1.csv"),row.names=FALSE)
}  

########################
########  plot  ########
########################

library(vegan)
library(ggplot2)
library(reshape2)
library(RColorBrewer)
require(gridExtra)

####biomass plot####
for(j in 1:3){
  
  #####Scenarios with SLR######  
  index_total_benthos_0 <- read.csv(paste0("./output/result_data/index/1000/biomass_benthos_sal", j,".csv"))
  index_total_plant_0 <- read.csv(paste0("./output/result_data/index/1000/biomass_plant_sal", j,".csv"))
  index_biomass_total_0 <- read.csv(paste0("./output/result_data/index/1000/biomass_total_sal", j,".csv"))
  
  index_total_benthos_slope <- read.csv(paste0("./output/result_data/index/1000_slope/biomass_benthos_sal", j,".csv"))
  index_total_plant_slope <- read.csv(paste0("./output/result_data/index/1000_slope/biomass_plant_sal", j,".csv"))
  index_biomass_total_slope <- read.csv(paste0("./output/result_data/index/1000_slope/biomass_total_sal", j,".csv"))
  
  index_total_benthos_1 <- read.csv(paste0("./output/result_data/index/1000_ele/biomass_benthos_sal", j,"_1.csv"))
  index_total_plant_1 <- read.csv(paste0("./output/result_data/index/1000_ele/biomass_plant_sal", j,"_1.csv"))
  index_biomass_total_1 <- read.csv(paste0("./output/result_data/index/1000_ele/biomass_total_sal", j,"_1.csv"))
  
  index_total_benthos_m1 <- read.csv(paste0("./output/result_data/index/1000_ele/biomass_benthos_sal", j,"_-1.csv"))
  index_total_plant_m1 <- read.csv(paste0("./output/result_data/index/1000_ele/biomass_plant_sal", j,"_-1.csv"))
  index_biomass_total_m1 <- read.csv(paste0("./output/result_data/index/1000_ele/biomass_total_sal", j,"_-1.csv"))
  
  #####Scenarios without SLR######  
  # index_total_benthos_0 <- read.csv(paste0("./output/result_data/index/1000_slr0/biomass_benthos_sal", j,".csv"))
  # index_total_plant_0 <- read.csv(paste0("./output/result_data/index/1000_slr0/biomass_plant_sal", j,".csv"))
  # index_biomass_total_0 <- read.csv(paste0("./output/result_data/index/1000_slr0/biomass_total_sal", j,".csv"))
  # 
  # index_total_benthos_slope <- read.csv(paste0("./output/result_data/index/1000_slope_slr0/biomass_benthos_sal", j,".csv"))
  # index_total_plant_slope <- read.csv(paste0("./output/result_data/index/1000_slope_slr0/biomass_plant_sal", j,".csv"))
  # index_biomass_total_slope <- read.csv(paste0("./output/result_data/index/1000_slope_slr0/biomass_total_sal", j,".csv"))
  # 
  # index_total_benthos_1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/biomass_benthos_sal", j,"_1.csv"))
  # index_total_plant_1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/biomass_plant_sal", j,"_1.csv"))
  # index_biomass_total_1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/biomass_total_sal", j,"_1.csv"))
  # 
  # index_total_benthos_m1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/biomass_benthos_sal", j,"_-1.csv"))
  # index_total_plant_m1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/biomass_plant_sal", j,"_-1.csv"))
  # index_biomass_total_m1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/biomass_total_sal", j,"_-1.csv"))
  # 
  
  data_benthos_ssc1 <- data.frame(cbind(index_total_benthos_slope[,1],index_total_benthos_m1[,1],index_total_benthos_0[,1],index_total_benthos_1[,1]))
  data_benthos_ssc2 <- data.frame(cbind(index_total_benthos_slope[,2],index_total_benthos_m1[,2],index_total_benthos_0[,2],index_total_benthos_1[,2]))
  data_benthos_ssc3 <- data.frame(cbind(index_total_benthos_slope[,3],index_total_benthos_m1[,3],index_total_benthos_0[,3],index_total_benthos_1[,3]))
  
  data_plant_ssc1 <- data.frame(cbind(index_total_plant_slope[,1],index_total_plant_m1[,1],index_total_plant_0[,1],index_total_plant_1[,1]))
  data_plant_ssc2 <- data.frame(cbind(index_total_plant_slope[,2],index_total_plant_m1[,2],index_total_plant_0[,2],index_total_plant_1[,2]))
  data_plant_ssc3 <- data.frame(cbind(index_total_plant_slope[,3],index_total_plant_m1[,3],index_total_plant_0[,3],index_total_plant_1[,3]))
  
  data_total_ssc1 <- data.frame(cbind(index_biomass_total_slope[,1],index_biomass_total_m1[,1],index_biomass_total_0[,1],index_biomass_total_1[,1]))
  data_total_ssc2 <- data.frame(cbind(index_biomass_total_slope[,2],index_biomass_total_m1[,2],index_biomass_total_0[,2],index_biomass_total_1[,2]))
  data_total_ssc3 <- data.frame(cbind(index_biomass_total_slope[,3],index_biomass_total_m1[,3],index_biomass_total_0[,3],index_biomass_total_1[,3]))
  
  getPalette1 <- colorRampPalette(brewer.pal(9, "Greens"))
  getPalette2 <- colorRampPalette(brewer.pal(9, "Blues"))
  getPalette3 <- colorRampPalette(brewer.pal(9, "Reds"))
  color <- c(rep(getPalette1(6)[4],3),rep(getPalette2(6)[4],3))
  color_total <- getPalette3(6)[2:4]
  
  
  
  coeff_total <- 8
  #coeff_total <- 12#slr0
  for(m in 1:3){
    color_plot <- c(color[m],color[m],color[m],color[m],color[m+3],color[m+3],color[m+3],color[m+3],color_total[m],color_total[m],color_total[m],color_total[m])
    names(color_plot) <- c("slope_p","low_p","median_p","high_p","slope_b","low_b","median_b","high_b","slope_t","low_t","median_t","high_t")
    
    linetypes <- c("dotted","solid", "longdash", "F1","dotted","solid", "longdash", "F1","dotted","solid", "longdash", "F1")
    names(linetypes) <- c("slope_p","median_p","high_p","low_p","slope_b","median_b","high_b","low_b","slope_t","median_t","high_t","low_t")
    
    eval(parse(text = paste0('colnames(data_benthos_ssc',m,') <-c("slope_b","low_b","median_b","high_b") ')))
    eval(parse(text = paste0('colnames(data_plant_ssc',m,') <-c("slope_p","low_p","median_p","high_p") ')))
    eval(parse(text = paste0('colnames(data_total_ssc',m,') <-c("slope_t","low_t","median_t","high_t") ')))
    
    eval(parse(text = paste0('data_benthos_ssc',m,'$Year <-seq(1,100,1) ')))
    eval(parse(text = paste0('data_plant_ssc',m,'$Year <-seq(1,100,1) ')))
    eval(parse(text = paste0('data_total_ssc',m,'$Year <-seq(1,100,1) ')))
    
    # eval(parse(text = paste0('data_benthos_ssc',m,'$group <-"benthos" ')))
    # eval(parse(text = paste0('data_plant_ssc',m,'$group <-"plant" ')))
    # eval(parse(text = paste0('data_total_ssc',m,'$group <-"total" ')))
    
    eval(parse(text = paste0('data_benthos_plot <- melt(data_benthos_ssc',m,',id="Year")')))
    eval(parse(text = paste0('data_plant_plot <- melt(data_plant_ssc',m,',id="Year")')))
    eval(parse(text = paste0('data_total_plot <- melt(data_total_ssc',m,',id="Year")')))
    
    p <- ggplot( ) +
      geom_line(data_benthos_plot, mapping=aes(Year, value, group = variable,linetype=variable,col=variable),size=3)+
      geom_line(data_plant_plot, mapping=aes(Year, value/coeff_total, group = variable,linetype=variable,col=variable),size=3)+
      scale_colour_manual(values=color_plot,name=" ")+
      scale_linetype_manual(values=linetypes)+#c("solid","solid", "dashed", "dashed","dotdash", "dotdash")
      scale_y_continuous(
        limits = c(0, 1),
        name = "Geometric-mean biomass",
        breaks=c(0,0.5,1),
        
        # Add a second axis and specify its features
        sec.axis = sec_axis(~.*coeff_total, name=" ",breaks=c(0,4,8))
      )+
      scale_x_continuous(
        name = "Year" ,
      )+
      theme_classic()+
      
      theme(
        axis.text = element_text(size = 70),
        axis.title.y = element_text( size=60,margin = margin(t = 0, r = 5, b = 0, l = 0)),
        axis.title.y.right = element_text(size=60,margin = margin(t = 0, r =0 , b = 0, l = 5)),
        axis.title.x = element_text(size=70,margin = margin(t = 5, r = 0, b = 0, l = 0)),
        #plot.title = element_text(size = 30,hjust = 0.5),
        legend.text = element_text(size = 28),
        legend.position = "none"
      )
    
    #ggsave(p, file=paste0("./output/result_figure/benthos_zone/model0825/index/shann_benthos_point_sal",j,".png"), width = 30, height = 14, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/1000_ele/gam_c_sal",j,"_1.png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/1000_slr0/gam_c_sal",j,"_limited.png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/1000_slr0/compare_slr/gam_c_sal",j,".png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/strategy_compa/gam_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/strategy_compa/gam_slr0_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    ggsave(p, file=paste0("./output/result_figure/together/0607/index/ele_compa_colorRe/gam_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/0607/index/ele_compa_colorRe/gam_slr0_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    
  }
  
}


####richness plot####
for(j in 1:3){
  
  #####Scenarios with SLR###### 
  
  index_richness_benthos_0 <- read.csv(paste0("./output/result_data/index/1000/richness_benthos_sal", j,".csv"))
  index_richness_plant_0 <- read.csv(paste0("./output/result_data/index/1000/richness_plant_sal", j,".csv"))
  index_richness_total_0 <- read.csv(paste0("./output/result_data/index/1000/richness_total_sal", j,".csv"))
  
  index_richness_benthos_1 <- read.csv(paste0("./output/result_data/index/1000_ele/richness_benthos_sal", j,"_1.csv"))
  index_richness_plant_1 <- read.csv(paste0("./output/result_data/index/1000_ele/richness_plant_sal", j,"_1.csv"))
  index_richness_total_1 <- read.csv(paste0("./output/result_data/index/1000_ele/richness_total_sal", j,"_1.csv"))
  
  index_richness_benthos_slope <- read.csv(paste0("./output/result_data/index/1000_slope/richness_benthos_sal", j,".csv"))
  index_richness_plant_slope <- read.csv(paste0("./output/result_data/index/1000_slope/richness_plant_sal", j,".csv"))
  index_richness_total_slope <- read.csv(paste0("./output/result_data/index/1000_slope/richness_total_sal", j,".csv"))
  
  index_richness_benthos_m1 <- read.csv(paste0("./output/result_data/index/1000_ele/richness_benthos_sal", j,"_-1.csv"))
  index_richness_plant_m1 <- read.csv(paste0("./output/result_data/index/1000_ele/richness_plant_sal", j,"_-1.csv"))
  index_richness_total_m1 <- read.csv(paste0("./output/result_data/index/1000_ele/richness_total_sal", j,"_-1.csv"))
  
  #####Scenarios without SLR###### 
  
  # index_richness_benthos_0 <- read.csv(paste0("./output/result_data/index/1000_slr0/richness_benthos_sal", j,".csv"))
  # index_richness_plant_0 <- read.csv(paste0("./output/result_data/index/1000_slr0/richness_plant_sal", j,".csv"))
  # index_richness_total_0 <- read.csv(paste0("./output/result_data/index/1000_slr0/richness_total_sal", j,".csv"))
  # 
  # index_richness_benthos_1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/richness_benthos_sal", j,"_1.csv"))
  # index_richness_plant_1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/richness_plant_sal", j,"_1.csv"))
  # index_richness_total_1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/richness_total_sal", j,"_1.csv"))
  # 
  # index_richness_benthos_slope <- read.csv(paste0("./output/result_data/index/1000_slope_slr0/richness_benthos_sal", j,".csv"))
  # index_richness_plant_slope <- read.csv(paste0("./output/result_data/index/1000_slope_slr0/richness_plant_sal", j,".csv"))
  # index_richness_total_slope <- read.csv(paste0("./output/result_data/index/1000_slope_slr0/richness_total_sal", j,".csv"))
  # 
  # index_richness_benthos_m1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/richness_benthos_sal", j,"_-1.csv"))
  # index_richness_plant_m1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/richness_plant_sal", j,"_-1.csv"))
  # index_richness_total_m1 <- read.csv(paste0("./output/result_data/index/1000_ele_slr0/richness_total_sal", j,"_-1.csv"))
  # 
  
  
  data_benthos_ssc1 <- data.frame(cbind(index_richness_benthos_slope[,1],index_richness_benthos_m1[,1],index_richness_benthos_0[,1],index_richness_benthos_1[,1]))
  data_benthos_ssc2 <- data.frame(cbind(index_richness_benthos_slope[,2],index_richness_benthos_m1[,2],index_richness_benthos_0[,2],index_richness_benthos_1[,2]))
  data_benthos_ssc3 <- data.frame(cbind(index_richness_benthos_slope[,3],index_richness_benthos_m1[,3],index_richness_benthos_0[,3],index_richness_benthos_1[,3]))
  
  data_plant_ssc1 <- data.frame(cbind(index_richness_plant_slope[,1],index_richness_plant_m1[,1],index_richness_plant_0[,1],index_richness_plant_1[,1]))
  data_plant_ssc2 <- data.frame(cbind(index_richness_plant_slope[,2],index_richness_plant_m1[,2],index_richness_plant_0[,2],index_richness_plant_1[,2]))
  data_plant_ssc3 <- data.frame(cbind(index_richness_plant_slope[,3],index_richness_plant_m1[,3],index_richness_plant_0[,3],index_richness_plant_1[,3]))
  
  data_total_ssc1 <- data.frame(cbind(index_richness_total_slope[,1],index_richness_total_m1[,1],index_richness_total_0[,1],index_richness_total_1[,1]))
  data_total_ssc2 <- data.frame(cbind(index_richness_total_slope[,2],index_richness_total_m1[,2],index_richness_total_0[,2],index_richness_total_1[,2]))
  data_total_ssc3 <- data.frame(cbind(index_richness_total_slope[,3],index_richness_total_m1[,3],index_richness_total_0[,3],index_richness_total_1[,3]))
  
  getPalette1 <- colorRampPalette(brewer.pal(9, "Greens"))
  getPalette2 <- colorRampPalette(brewer.pal(9, "Blues"))
  getPalette3 <- colorRampPalette(brewer.pal(9, "Reds"))
  color <- c(rep(getPalette1(6)[4],3),rep(getPalette2(6)[4],3))
  color_total <- getPalette3(6)[2:4]
  
  
  coeff_total <- 1
  for(m in 1:3){
    color_plot <- c(color[m],color[m],color[m],color[m],color[m+3],color[m+3],color[m+3],color[m+3],color_total[m],color_total[m],color_total[m],color_total[m])
    names(color_plot) <- c("slope_p","low_p","median_p","high_p","slope_b","low_b","median_b","high_b","slope_t","low_t","median_t","high_t")
    
    linetypes <- c("dotted","solid", "longdash", "F1","dotted","solid", "longdash", "F1","dotted","solid", "longdash", "F1")
    names(linetypes) <- c("slope_p","median_p","high_p","low_p","slope_b","median_b","high_b","low_b","slope_t","median_t","high_t","low_t")
    
    eval(parse(text = paste0('colnames(data_benthos_ssc',m,') <-c("slope_b","low_b","median_b","high_b") ')))
    eval(parse(text = paste0('colnames(data_plant_ssc',m,') <-c("slope_p","low_p","median_p","high_p") ')))
    eval(parse(text = paste0('colnames(data_total_ssc',m,') <-c("slope_t","low_t","median_t","high_t") ')))
    
    eval(parse(text = paste0('data_benthos_ssc',m,'$Year <-seq(1,100,1) ')))
    eval(parse(text = paste0('data_plant_ssc',m,'$Year <-seq(1,100,1) ')))
    eval(parse(text = paste0('data_total_ssc',m,'$Year <-seq(1,100,1) ')))
    
    # eval(parse(text = paste0('data_benthos_ssc',m,'$group <-"benthos" ')))
    # eval(parse(text = paste0('data_plant_ssc',m,'$group <-"plant" ')))
    # eval(parse(text = paste0('data_total_ssc',m,'$group <-"total" ')))
    
    eval(parse(text = paste0('data_benthos_plot <- melt(data_benthos_ssc',m,',id="Year")')))
    eval(parse(text = paste0('data_plant_plot <- melt(data_plant_ssc',m,',id="Year")')))
    eval(parse(text = paste0('data_total_plot <- melt(data_total_ssc',m,',id="Year")')))
    
    p <- ggplot( ) +
      geom_line(data_benthos_plot, mapping=aes(Year, value, group = variable,linetype=variable,col=variable),size=3)+
      geom_line(data_plant_plot, mapping=aes(Year, value/coeff_total, group = variable,linetype=variable,col=variable),size=3)+
      scale_colour_manual(values=color_plot,name=" ")+#breaks=name_order
      scale_linetype_manual(values=linetypes)+
      scale_y_continuous(
        limits = c(0, 15),
        name = "Richness", 
        breaks=c(0,5,10,15),
        

      )+
      scale_x_continuous(
        name = "Year" ,
      )+
      theme_classic()+
      
      theme(
        axis.text = element_text(size = 70),
        axis.title.y = element_text( size=60,margin = margin(t = 0, r = 5, b = 0, l = 0)),
        axis.title.y.right = element_text(size=60,margin = margin(t = 0, r =0 , b = 0, l = 5)),
        axis.title.x = element_text(size=70,margin = margin(t = 5, r = 0, b = 0, l = 0)),
        #plot.title = element_text(size = 30,hjust = 0.5),
        legend.text = element_text(size = 28),
        legend.position = "none"
      )
    
    
    #ggsave(p, file=paste0("./output/result_figure/benthos_zone/model0825/index/shann_benthos_point_sal",j,".png"), width = 30, height = 14, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/1000_ele/gam_c_sal",j,"_1.png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/1000_slr0/gam_c_sal",j,"_limited.png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/1000_slr0/compare_slr/gam_c_sal",j,".png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/strategy_compa/richness_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/1026/index/ele_compa/Revised/richness_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    ggsave(p, file=paste0("./output/result_figure/together/0607/index/ele_compa_colorRe/richness_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
    #ggsave(p, file=paste0("./output/result_figure/together/0607/index/ele_compa_colorRe/richness_slr0_sal",j,"ssc",m,".png"), width = 45, height = 30, units = "cm")#change index
  }
}