library(plotly)

for(k in 1:3){ #ssc
  for(j in 1:3){ #salzone
    for(i in c(1,2,5:20,24)){ #species
      #result_spe <- read.csv(paste0("./output/result_data/benthos_zone/0926/ssc", k,"/1000/100years/lowdynam/median_bs_sal", j,"_spe",i,".csv"))
      #result_spe <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_slope/median_bs_sal", j,"_spe",i,".csv"))
      #result_spe <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_ele/median_bs_sal", j,"_spe",i,"_1.csv"))
      #result_spe <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_slr0/median_bs_sal", j,"_spe",i,".csv"))
      #result_spe <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000/median_bs_sal", j,"_spe",i,".csv"))
      result_spe <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_slope_slr0/median_bs_sal", j,"_spe",i,".csv"))
      B0 <- result_spe[1,]
      
      N0 <- c(1,1,0,0,0.4,0.012,0.166,0.9,0.006,0.047,1,1,0.6,0.39,0.4,1,0.1,0.4,0,0.9,0,0,0,0.7,0)#1:25
      r_data <-c(1.77,2.655,0,0,0.708,0.663,1.18,5.31,0.708,2.124,3.54,5.31,1.32,3.54,1.32,5.31,0.354,0.708,2.655,5.31,0,0,0,1.514,2.3)
      B <- N0[i]*B0
      r <- r_data[i]
      
      ###### Parameters of simulation ######
      
      endtime <- 101
      result <- data.frame(matrix(NA, nrow = endtime-1, ncol = ncol(result_spe)))
      
      ###### simulation ######
      
      t <- 1
      while(t<endtime){
        
        K_spe <- result_spe[t,]
        
        B <- pmin(B,K_spe)
        dB <- r*B*(1-B/K_spe)
        #dB[dB<0] <- 0
        dB[dB== -Inf] <- 0#K_spe=0
        B <- B+dB
        B <- pmin(B,K_spe)
        
        result[t,] <- B[,]
        t=t+1
      }
      #write.csv(result,paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_slope/logistic/logistic_spe", i,"_sal",j,".csv"),row.names=FALSE)
      #write.csv(result,paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_ele/logistic/logistic_spe", i,"_sal",j,"_1.csv"),row.names=FALSE)
      #write.csv(result,paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_slr0/logistic/logistic_spe", i,"_sal",j,".csv"),row.names=FALSE)
      #write.csv(result,paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000/logistic/logistic_spe", i,"_sal",j,".csv"),row.names=FALSE)
      write.csv(result,paste0("./output/result_data/benthos_zone/1026/ssc", k,"/1000_slope_slr0/logistic/logistic_spe", i,"_sal",j,".csv"),row.names=FALSE)
    }
    
  }
  
}

##########  plot  ############
###single species
result <- read.csv("./output/result_data/benthos_zone/model0825/ssc1/100years_logistic2/logistic_spe5_sal1.csv")
colnames(result) <- seq(1,401,length.out=401)
result$time<-seq(1,100,length.out=100)


data <- melt(result,id='time')
z <- xtabs(value ~ time + variable, data = data)
plot_ly(z = ~z) %>% add_surface()