library(brms)
library(tidyverse)
library(tidybayes)
library(posterior)
library(reshape2)

specnames <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\specnames_plant.rds")


I_pre0=read.csv("C:\\Users\\xwu\\python_working\\1dTidalModel\\output\\0926\\zone1\\1000_slope\\I_zone1_ssc1_slr0.csv",stringsAsFactors = F)
sal_zone <- c("Sterk polyhalien","Zwak polyhalien","Mesohalien")


for(l in 1:3){#ssc
  for(j in 1:length(specnames)){
    for(i in 1:length(sal_zone)){
      eval(parse(text = paste0('result_spe_median_sal',i,'_spe',j,' <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(I_pre0)-1))')))
      eval(parse(text = paste0('result_spe_quan95_sal',i,'_spe',j,' <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(I_pre0)-1))')))
      eval(parse(text = paste0('result_spe_mean_sal',i,'_spe',j,' <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(I_pre0)-1))')))
      eval(parse(text = paste0('result_spe_occur_sal',i,'_spe',j,' <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(I_pre0)-1))')))
    }}
  
  for(k in seq(1,601,6)){ #time
    for(i in 1:length(sal_pre)){
      #eval(parse(text = paste0('I_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_ele/I_zone',i,'_ssc',l,'_slr2_1.csv",stringsAsFactors = F)')))
      #eval(parse(text = paste0('B_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_ele/B_zone',i,'_ssc',l,'_slr2_1.csv",stringsAsFactors = F)')))
      #eval(parse(text = paste0('I_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/I_zone',i,'_ssc',l,'_slr2.csv",stringsAsFactors = F)')))
      #eval(parse(text = paste0('B_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/B_zone',i,'_ssc',l,'_slr2.csv",stringsAsFactors = F)')))
      #eval(parse(text = paste0('I_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/I_zone',i,'_ssc',l,'_slr0.csv",stringsAsFactors = F)')))
      #eval(parse(text = paste0('B_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/B_zone',i,'_ssc',l,'_slr0.csv",stringsAsFactors = F)')))
      eval(parse(text = paste0('I_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_slope/I_zone',i,'_ssc',l,'_slr0.csv",stringsAsFactors = F)')))
      eval(parse(text = paste0('B_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_slope/B_zone',i,'_ssc',l,'_slr0.csv",stringsAsFactors = F)')))

      #predict data
      I_pre_t <- as.numeric(as.vector(I_pre[k,2:ncol(I_pre)]))
      B_pre_t <- as.numeric(as.vector(B_pre[k,2:ncol(I_pre)]))
      
      pred_cov <-data.frame(matrix(NA, nrow = length(I_pre_t)*8000, ncol = 17))
      pred_cov_draw<-data.frame(matrix(NA, nrow = length(I_pre_t)*8000, ncol = 17))
      colnames(pred_cov)<-specnames
      colnames(pred_cov_draw)<-specnames
      
      #load model of species
      for(j in 1:length(specnames)){
        eval(parse(text = paste0('load("C:/Users/xwu/R_working/workspace2/ecology model/output/model/model_bs_plant/ele/model_hurdle_plant_bs_',j,'.Rdata")')))
        #abundance
        tidy_pred <- model_hurdle_fit %>% 
          epred_draws(newdata = data.frame(ELEVATION=I_pre_t,salzone=sal_zone[i]))
        tidy_pred$.epred[tidy_pred$.epred<0.00001]=0
        pred_cov[,j] <-tidy_pred$.epred
        #occurrence
        tidy_pred_draw <- model_hurdle_fit %>% 
          predicted_draws(newdata = data.frame(ELEVATION=I_pre_t,salzone=sal_zone[i]))
        tidy_pred_draw$.prediction[tidy_pred_draw$.prediction<0.00001]=0
        pred_cov_draw[,j] <-tidy_pred_draw$.prediction
      } 
      Cov_total=rowSums(pred_cov)
      B_pre_t_rep <- rep(B_pre_t,each=8000)
      pred_bio <- pred_cov*B_pre_t_rep/Cov_total
      pred_bio$row <-tidy_pred$.row
      pred_bio$draw <-tidy_pred$.draw
      pred_cov_draw$row <- tidy_pred_draw$.row
      pred_cov_draw$draw <- tidy_pred_draw$.draw
      
      for(m in 1:length(specnames)){
        posterior_median <- pred_bio %>%
          select(draw,row,specnames[m]) %>% 
          group_by(row) %>% 
          reframe(prob=sum(.data[[specnames[m]]]>0,na.rm = TRUE)/8000,median=median(.data[[specnames[m]]],na.rm = TRUE),quan95= quantile(.data[[specnames[m]]],0.95,na.rm = TRUE),mean=mean(.data[[specnames[m]]],na.rm = TRUE),sd=sd(.data[[specnames[m]]],na.rm = TRUE)) #%>% 
        
        posterior_occur <- pred_cov_draw %>%
          select(draw,row,specnames[m]) %>% 
          group_by(row) %>% 
          summarise(prob=sum(.data[[specnames[m]]]>0,na.rm = TRUE)/8000)
        
        eval(parse(text = paste0('result_spe_median_sal',i,'_spe',m,'[(k+5)/6,] <- posterior_median$median')))
        eval(parse(text = paste0('result_spe_quan95_sal',i,'_spe',m,'[(k+5)/6,] <- posterior_median$quan95')))
        eval(parse(text = paste0('result_spe_mean_sal',i,'_spe',m,'[(k+5)/6,] <- posterior_median$mean')))
        eval(parse(text = paste0('result_spe_occur_sal',i,'_spe',m,'[(k+5)/6,] <- posterior_median$prob')))
        
      }
    }}
  
  for(j in 1:length(specnames)){
    for(i in 1:length(sal_pre)){
      # eval(parse(text = paste0('write.csv(result_spe_median_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_ele/plant_median_sal',i,'_spe',j,'_1.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_quan95_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_ele/plant_quan95_sal',i,'_spe',j,'_1.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_mean_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_ele/plant_mean_sal',i,'_spe',j,'_1.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_occur_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_ele/plant_occur_sal',i,'_spe',j,'_1.csv",row.names=FALSE)')))
      
      # eval(parse(text = paste0('write.csv(result_spe_median_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000/plant_median_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_quan95_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000/plant_quan95_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_mean_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000/plant_mean_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_occur_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000/plant_occur_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      
      # eval(parse(text = paste0('write.csv(result_spe_median_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slr0/plant_median_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_quan95_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slr0/plant_quan95_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_mean_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slr0/plant_mean_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      # eval(parse(text = paste0('write.csv(result_spe_occur_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slr0/plant_occur_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      
      eval(parse(text = paste0('write.csv(result_spe_median_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slope_slr0/plant_median_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      eval(parse(text = paste0('write.csv(result_spe_quan95_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slope_slr0/plant_quan95_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      eval(parse(text = paste0('write.csv(result_spe_mean_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slope_slr0/plant_mean_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      eval(parse(text = paste0('write.csv(result_spe_occur_sal',i,'_spe',j,',"./output/result_data/plant_zone/0926/ssc',l,'/1000_slope_slr0/plant_occur_sal',i,'_spe',j,'.csv",row.names=FALSE)')))
      
    }}
  }
